#!/usr/bin/env python3
""" Statistical Language Processing (SNLP), Assignment 2
    See <https://snlp2020.github.io/a2/> for detailed instructions.

    <Please insert your name and the honor code here.>
"""

def read_data(filename, shuffle=True):
    """ Read the tab-separated training or test files.

    Parameters:
    -----------
    filename:  The name of the file to read.
    shuffle:   If true, the instances should be shuffled (make sure
               not scramble correspondences between the predictors and
               the outcomes).

    Returns: (a tuple)
    -----------
    age:        A 1D numpy array with the first (age) column.
    features:   A 2D (n_instances x n_features) with numeric features
                (including the document length, which should be the first
                column.)
    """
    ### Exercise 2.1

def correlate(xseq, yseq):
    """Return the correlation coefficient between the given sequences.
    """
    ### Exercise 2.2

def regression_scores(x_train, y_train, x_dev=None, y_dev=None, lambda_=None):
    """Train a regression model and return rmse and r2.
    
    If x_dev and y_dev are None, scores are calculated on the
    training data, otherwise on the development (validation) data.

    Parameters:
    -----------
    x_train:   Feature matrix for training (A 2D numpy array)
    y_train:   The values to predict.
    x_dev:     Same as x_train, for development data.
    y_dev:     Same as y_train, for development data.
    lambda_:   If None, train a least-squares regression model,
               otherwise train a L2-regularized regression (Ridge)
               with given regularization strength.

    Returns: (a tuple)
    -----------
    rmse:       Root mean squared error.
    r-squared:  The coefficient of determination (R-squared)
    """
    ### The main code for 2.3 and 2.4 goes here


def tune(x_train, y_train, x_dev, y_dev):
    """Tune the regularization strength of a L2-regularized regression model.

    You are free to choose the method the range to search. Most
    straightforward method is to use a "grid search", calculating the
    r2 values in a range with a small step, and returning the constant
    that yields the best r2 score. However, there are more interesting
    and/or more efficient ways to look for the best hyperparameter.

    Parameters:
    -----------
    x_train:   Feature matrix for training (A 2D numpy array)
    y_train:   The values to predict.
    x_dev:     Same as x_train, for development data.
    y_dev:     Same as y_train, for development data.

    """
    ### Exercise 2.5

if __name__ == "__main__":
    train_file = 'train.tsv.gz'
    test_file = 'test.tsv.gz'

    ### E2.1 - read the data
    age, feats = read_data(train_file)
    ### train/dev splitting goes below the code below assumes that 
    ### they are prefixed with train_ and dev_ respectively


    ### E2.2
    print("Correlation between age and length: {}.".format(
        correlate(age, feats[:, 0])))
    print("From numpy                          {}.".format(
        np.corrcoef(age, feats[:,0])[0,1]))

    ### E2.3 - calculate (using print regression_scores()) and print
    ###        out the required scores below

    ### E2.4 - calculate (using print regression_scores()) and print
    ###        out the required scores below

    ### E2.5 - tune and obtain the best regularization constant
    best_l = tune(train_feats, train_age, dev_feats, dev_age)
    print("Best regularization strength: {}.".format(best_l))

    ### E2.6 - Write test predictions to 'predictions.txt'
    _, test_feats = read_data(test_file)
